//
//  ViewController.swift
//  enum_func
//
//  Created by yoshiyuki oshige on 2017/07/30.
//  Copyright © 2017年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    
    enum Signal:String {
        case Green = "緑色"
        case Red = "赤色"
        
        // 値を色名（rawValue）で返す
        var color:String {
            return self.rawValue
        }
        
        // 説明文を返すタイプメソッド
        static func description() -> String {
            return "GreenまたはRedのシグナルです。"
        }
        
        // 値をBoolで返す（Greenのときtrue、そうでないときfalse）
        func isRun() -> Bool{
            if self == .Green {
                return true
            } else  {
                return false
            }
        }
        
        // GreenならばRed、RedならばGreenに値を切り替える
        mutating func turn(){
            if self == .Green {
                self = .Red
            } else {
                self = .Green
            }
        }
        
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // タイプメソッドを実行する
        let text = Signal.description()
        print(text)
        // 最初はGreenで開始する
        var lamp = Signal.Green
        print(lamp.color)
        print(lamp.isRun())
        print("---- 値を反転する ----")
        lamp.turn()
        print(lamp.color)
        print(lamp.isRun())
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
}


